---
version: '3'

networks:
  traefik_network:
    external:
      name: homelabos_traefik

services:
  openldap:
    image: osixia/openldap:1.2.2
    restart: unless-stopped
    networks:
      - traefik_network
    ports:
      - 389:389
      - 689:689
    volumes:
      - "{{ volumes_root }}/openldap/data:/var/lib/data"
      - "{{ volumes_root }}/openldap/config:/etc/ldap/slapd.d"
    environment:
      - LDAP_ORGANISATION="{{ ldap_org_name }}"
      - LDAP_DOMAIN="{{ domain }}"
      - LDAP_ADMIN_PASSWORD="{{ default_password }}"

  phpldapadmin:
    image: osixia/phpldapadmin:0.7.2
    restart: unless-stopped
    networks:
      - traefik_network
    environment:
      - PHPLDAPADMIN_LDAP_HOSTS=openldap
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=homelabos_traefik"
      - "traefik.http.services.phpldapadmin.loadbalancer.server.scheme=http"
      - "traefik.http.services.phpldapadmin.loadbalancer.server.port=80"
      - "traefik.http.routers.phpldapadmin-http.rule=Host(`phpldapadmin.{{ domain }}`)"
      - "traefik.http.routers.phpldapadmin-http.entrypoints=http"
      - "traefik.http.routers.phpldapadmin-http.middlewares={% if openldap.https_only %}redirect@file, {% else %}{% if openldap.auth %}{% if enable_authelia %}authelia@file{% else %}basicAuth@file{% endif %}, {% endif %}{% endif %}customFrameHomelab@file"
      - "traefik.http.routers.phpldapadmin.rule=Host(`phpldapadmin.{{ domain }}`)"
      - "traefik.http.routers.phpldapadmin.entrypoints=https"
      - "traefik.http.routers.phpldapadmin.middlewares={% if openldap.auth %}{% if enable_authelia %}authelia@file{% else %}basicAuth@file{% endif %}, {% endif %}customFrameHomelab@file"
      - "traefik.http.routers.phpldapadmin.tls=true"
{% if traefik.dns_challenge_provider %}
      - "traefik.http.routers.phpldapadmin.tls.certresolver=dns"
      - "traefik.http.routers.phpldapadmin.tls.domains[0].main={{ domain }}"
      - "traefik.http.routers.phpldapadmin.tls.domains[0].sans=*.{{ domain }}"
{% else %}
      - "traefik.http.routers.phpldapadmin.tls.certresolver=http"
{% endif %}
{% if enable_tor %}
      - "traefik.http.routers.phpldapadmin-tor-http.rule=Host(`phpldapadmin.{{ tor_domain }}`)"
      - "traefik.http.routers.phpldapadmin-tor-http.entrypoints=http"
      - "traefik.http.routers.phpldapadmin-tor-http.middlewares={% if phpldapadmin.auth %}{% if enable_authelia %}authelia-tor@file{% else %}basicAuth@file{% endif %}, {% endif %}customFrameHomelab-tor@file"
{% endif %}
